#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct TableColumnLogConfig {
    #[builder(custom(type = super::TableColumnLogAggregation, convert = Box::new))]
    #[serde(rename = "aggregation")]
    aggregation: Box<super::TableColumnLogAggregation>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::TableColumnLogAggregation>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "summaryRowAggregation",
        skip_serializing_if = "Option::is_none",
        default
    )]
    summary_row_aggregation: Option<Box<super::TableColumnLogAggregation>>,
    #[builder(default, list(item(type = super::LogColumnName)))]
    #[serde(rename = "visibleLogFields", skip_serializing_if = "Vec::is_empty", default)]
    visible_log_fields: Vec<super::LogColumnName>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::LogColumnTagFilters>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "tagFilters", skip_serializing_if = "Option::is_none", default)]
    tag_filters: Option<Box<super::LogColumnTagFilters>>,
}
impl TableColumnLogConfig {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(aggregation: super::TableColumnLogAggregation) -> Self {
        Self::builder().aggregation(aggregation).build()
    }
    #[inline]
    pub fn aggregation(&self) -> &super::TableColumnLogAggregation {
        &*self.aggregation
    }
    #[inline]
    pub fn summary_row_aggregation(&self) -> Option<&super::TableColumnLogAggregation> {
        self.summary_row_aggregation.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn visible_log_fields(&self) -> &[super::LogColumnName] {
        &*self.visible_log_fields
    }
    #[inline]
    pub fn tag_filters(&self) -> Option<&super::LogColumnTagFilters> {
        self.tag_filters.as_ref().map(|o| &**o)
    }
}
